% Article proposed to mdpi-INVENTIONS
% The computation of the statistical parameters -Table 4
% after  the 30 executions made by the script "cycle30single.m",
% and the drawing of Figure 3.

global t_vector u_vector;
global command_index;

load('WSP30single20','Ustar','JMAT');
str=sprintf('Medium performance index: %8.1f \n',mean(JMAT));
disp(str);
DJ=JMAT-mean(JMAT);
i0=1;
for i=2:30
    if(abs(DJ(i))<abs(DJ(i0)))
        i0=i;
    end
end

horiz=54.;
Nt=20;
X00=[1. 150. 0. 10.];
delt=horiz/Nt;
t_vector=0:delt:horiz; % are Nt+1 elemente
u_vector=Ustar(i0,:);

JMAT


str=sprintf('Typical solution:');disp(str);
disp('i0=');disp(i0);
str=sprintf('Jtyp = %8.1f\n',JMAT(i0));
disp(str);
str=sprintf('JMIN = %8.1f\n',min(JMAT));
disp(str);
str=sprintf('JMean = %8.1f\n',mean(JMAT));
disp(str);
str=sprintf('JMAX = %8.1f\n',max(JMAT));
disp(str);
str=sprintf('STDEV = %8.1f\n',std(JMAT));
disp(str);

str=sprintf('#####   Typical optimum profile control:');
disp(str);
str=sprintf('%8.3f \n', u_vector);
disp(str);    


%**************************************************************
figure(3)
stairs(t_vector,[u_vector(1:Nt),u_vector(Nt)],'r');
xlabel('time [h]');
ylabel('control input ');
axis([0,54,0,12]);
grid MINOR;
%text(3.2,2,strcat('Q_{0}=',num2str(Q0)),'FontSize',14);
text(10.,10.,'\it{H}=20','FontSize',12);
text(10.,9,'open-loop','FontSize',12);


figure(33)
command_index=1;
tf=horiz;
options = odeset('RelTol',1e-2,'MaxStep',1.,'NonNegative',[1,2,3,4]);
[T,Y] = ode23('EtanolProd',[0 tf],X00,options);


plot(T,Y(:,1),'-.k',T,Y(:,2),'-.g',T,Y(:,3),'-.r',T,Y(:,4),'-.b');
axis([0,54,0,210]);
xlabel('time [h]');
ylabel('state variables');
legend('\it{x}_{1}','\it{x}_{2}','\it{x}_{3}','\it{x}_{4}',...
   'position',[200 180 20 30]);% 'location','best');
text(10.,190.,'\it{H}=20','FontSize',12);
text(10.,170,'open-loop','FontSize',12);
grid MINOR;
IF=length(T); %IF este indicile final
J2=Y(IF,3)*Y(IF,4);
str=sprintf('\nJmax test: %8.1f',J2);
disp(str);
%*****************************************************************




